(function(){
    console.log('Responsive WebGL Template by SIMMER.io v2019.02.08');
    console.log('Available at: https://assetstore.unity.com/packages/tools/gui/responsive-webgl-template-117308 for free!');
    console.log('Host your WebGL Game at SIMMER.io for free!');

    const q = (selector) => document.querySelector(selector);

    const unityContainer = q('#gameContainer');
    let unityCanvas = null;

    const initialDimensions = {width: 480, height: 800};
    unityContainer.style.width = '100%';
    unityContainer.style.height = '100%';
    unityContainer.style.position = 'absolute';

    const initCanvas = (canvas) => {
        unityCanvas = canvas;
        unityCanvas.style.width = '100%';
        unityCanvas.style.height = '100%';
        unityCanvas.style.position = 'fixed';
        unityCanvas.style.transform = 'translate(-50%, -50%)';
        unityCanvas.style.top = '50%';
        unityCanvas.style.left = '50%';

        window.addEventListener('resize', setDimensions, false);
        setDimensions();
    }

    const setDimensions = () => {
        var scale = Math.min(window.innerWidth / initialDimensions.width, window.innerHeight / initialDimensions.height);

        var fitW = initialDimensions.width * scale;
        var fitH = initialDimensions.height * scale;

        unityCanvas.style.width = fitW + 'px';
        unityCanvas.style.height = fitH + 'px';
    }

    window.UnityLoader.Error.handler = function () { };


    const getCanvasFromMutationsList = (mutationsList) => {
        for (let mutationItem of mutationsList){
            for (let addedNode of mutationItem.addedNodes){
                if (addedNode.id === '#canvas'){
                    return addedNode;
                }
            }
        }
        return null;
    }
    new MutationObserver(function (mutationsList) {
        const canvas = getCanvasFromMutationsList(mutationsList)
        if (canvas){
            initCanvas(canvas);
            this.disconnect();
        }
    }).observe(unityContainer, {childList:true});

})();